% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese]{examjh}
\usepackage{../../../computingfonts}
\usepackage{../../../contentmacros}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{\sc MA 208, Theory of Computation\hfill Weekly Hand-in\hfill Due: 2022-Feb-21}
\vspace*{1ex}
\begin{center}
 \parbox{0.95\textwidth}{\textit{
  The work that you hand in must be entirely your own. 
  When you write this document, you may not work with anyone else,
  or copy material from the Internet, etc.
  You are of course allowed to use the text, the videos, or the notes
  or discussions from class.
  }}
\end{center}
\vspace*{1ex}
\begin{questions}
\question
Use Rice's Theorem to show that this problem is unsolvable: given an index~$e$,
decide if Turing machine~$e$ acts as this function.
\begin{equation*}
  f(x)=
  \begin{cases}
    4   &\case{if $x$ is prime}  \\
    1+x &\case{otherwise}
  \end{cases}
\end{equation*}
\begin{solution}
Let $\mathcal{I}=\set{e\suchthat \TMfcn_e=f}$.  
We will show that $\mathcal{I}$ is a nontrivial index set.

First, observe that we can write a program to compute~$f$, so by 
Church's Thesis there is a Turing machine with that behavior.
The index of that machine, $e_0$, is a member of~$\mathcal{I}$,
so $I$ is not empty.

Second, observe that there is a Turing machine that halts on no inputs,
and its index, $e_1$, is not a member of~$I$.
So $\mathcal{I}\neq\N$.

Finally, suppose that $e\in\mathcal{I}$ and that 
$\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$.
Because $e\in\mathcal{I}$ we know that
\begin{equation*}
  \TMfcn_e(x)=
  \begin{cases}
    4   &\case{if $x$ is prime}  \\
    1+x &\case{otherwise}
  \end{cases}
\end{equation*}
and because $\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$ it therefore follows that
\begin{equation*}
  \TMfcn_{\hat{e}}(x)=
  \begin{cases}
    4   &\case{if $x$ is prime}  \\
    1+x &\case{otherwise}
  \end{cases}
\end{equation*}
and so $\hat{e}\in\mathcal{I}$ also.

Thus $\mathcal{I}$ is a nontrivial index set.
\end{solution}


\end{questions}
\end{document}